Essential CSS
JavaScript Roadmap
Learn JavaScript
Mastering Web Typography
Practical Astro
Understanding Async JS
Unorthodox Tailwind
API Masterclass
Build and Deploy
The Beginner Freelancer
Real World Node
Profile Billing Logout
Understanding Async JS
Lesson Plan
  1. Introduction
    1. What is Asynchronous JS?
    2. Callbacks are not automatically asynchronous
    3. What is an API?
    4. Evolution of HTTP APIs
    5. Ajax vs Asynchronous JavaScript
  2. Fundamental Concepts
    1. How to fetch resources
    2. Using XHR
    3. Using the Fetch API
    4. Using libraries
    5. Core JavaScript concepts
    6. Understanding Promises
    7. Understanding Async Functions
    8. Understanding the Event Loop
    9. Understanding JSON
    10. Async JS Best Practices
    11. Using Optimistic UI
  3. Understanding Rest API
    1. Diving into Rest APIs
    2. The Rest Architecture
    3. The Rest Structure
    4. Anatomy of a Request
    5. What's an endpoint
    6. Request methods
    7. Understanding request headers
    8. Understanding the request body
    9. Authentication
    10. Basic Authentication
    11. Bearer Authentication
    12. Authenticating with API keys and API Secrets
    13. Cross Origin Resource Sharing
    14. Anatomy of a response
    15. HTTP Statuses
    16. Response headers
    17. The response body
    18. Handling Errors
    19. Reading API documentations
    20. Understanding Curl
  4. Node Basics
    1. Why we are using Node
    2. Command Line Basics
    3. Installing Node
    4. Managing dependencies
    5. Using ES Modules in Node
    6. Using Node
    7. Restarting the server automatically
    8. Sending requests via Node
    9. Protecting API keys and secrets
  5. Building a server
    1. What's a server
    2. Building a simple server with Express
    3. Two kinds of servers
    4. API Server architecture
    5. Handling routes
    6. Understanding Middlewares
    7. Enabling CORS
    8. Receiving data
    9. Sending responses
    10. Handling errors in Express
    11. Using the server as a proxy
    12. Minimum viable server
  6. Open Authorization
    1. Open Authorisation (OAuth)
    2. Authenticating with Access Tokens
    3. Obtaining Access Tokens
    4. Public and Confidential Clients
    5. Authorisation Code Grant
    6. Understanding scope
    7. Proof Key for Code Exchange (PKCE)
    8. PKCE with Twitter
    9. Dynamic state and `code_verifier`
    10. Saving the access token in cookies
    11. Passing access tokens to the browser
    12. Saving the access token in local storage
    13. Refresh Token Grant
    14. Device Code Grant
    15. Client libraries vs REST
  7. Building Social Media Logins
    1. Introduction
    2. Starter Files
    3. Creating SSL certificates
    4. Login in with Github
    5. Github: Saving the token to local storage
    6. Github: Persisting the login status
    7. Login with Twitter
    8. Twitter: Saving the token to local storage
    9. Twitter: Persisting the login status
    10. Twitter: Refreshing the access token
    11. Login with Facebook
    12. Facebook: Saving the token to localStorage
    13. Facebook: Persisting the login status
    14. Facebook: Refreshing the access token
    15. Login with google
    16. Google: Saving the token to localStorage
    17. Google: Refreshing the access token

What's an endpoint

1m:39s

The endpoint is the URL you send a request to. It is made up of three parts:

  1. The root
  2. The path
  3. Query parameters

Here’s an example of an endpoint that contains all three parts.

Terminal window
https://api.github.com/users/zellwk/repos?per_page=100
Picture depicting the difference between root, path, and query parameters

Root

The root (or root endpoint) is the origin of the API.

The origin contains three things:

  1. A Protocol (the file://, http:// or https:// part)
  2. A Host (the domain name)
  3. A Port (the number that comes after the domain name
Terminal window
# Example of origins
https://zellwk.com
https://students.magicaldevschool.com
https://api.github.com
http://locahost:3000

Each API will only have one root.

Path

The path is the part that comes after the root, but before ? (if any).

You can think about paths in the same way you would think about files and folders on your computer.

If you have folder a called blog and a file called article inside that folder, the path to this article file would be:

Terminal window
project-folder/blog/article

Here:

  • project-folder is the root
  • /blog/article is the path.

Each path lets you fetch a unique resource.

  • The following path lets you fetch my repositories from GitHub.
  • Other paths will fetch other things.
Terminal window
https://api.github.com/users/zellwk/repos

Query Parameters

Query parameters are key-value pairs that let you change the parameters of a response.

  • Query parameters always begin with a ?.
  • You use = to define the key-value pair of the parameter.
  • You use & to specify another query parameter.

Here’s what they look like:

Terminal window
?query1=value1&query2=value2

Query parameters will be listed in the documentation (next to information about the path) if they are available.

For example, here are the available parameters for fetching a user’s repositories on GitHub.

Query Parameters in Github

By default, Github returns 30 repositories. You can change the number of repositories returned by adding a per_page query parameter.

Terminal window
https://api.github.com/users/zellwk/repos?per_page=100